# $Revision: 1.51 $, $Date: 2006/01/06 20:19:45 $
#
# Conditional build:
%bcond_without	dist_kernel	# build without distribution kernel-headers
#
Summary:	Minimalistic libc subset for use with initramfs
Summary(pl):	Zminimalizowany podzbir biblioteki C do uywania z initramfs
Name:		klibc
Version:	1.1.16
Release:	1
License:	BSD/GPL
Group:		Libraries
Source0:	http://www.kernel.org/pub/linux/libs/klibc/Testing/%{name}-%{version}.tar.bz2
# Source0-md5:	80b85e84306695ed61049720008dd409
Patch0:		%{name}-klcc.patch
Patch1:		%{name}-kill_interp_sohash.patch
URL:		http://www.zytor.com/mailman/listinfo/klibc/
%{?with_dist_kernel:BuildRequires:	kernel-headers >= 2.4}
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	rpmbuild(macros) >= 1.153
BuildRequires:	perl-base
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip	1

%description
klibc, what is intended to be a minimalistic libc subset for use with
initramfs. It is deliberately written for small size, minimal
entaglement and portability, not speed. It is definitely a work in
progress, and a lot of things are still missing.

%description -l pl
klibc w zamierzeniu ma by minimalistycznym podzbiorem biblioteki libc
do uycia z initramfs. Celem jest minimalizacja, przenono ale nie
szybko. klibc jest rozwijan bibliotek w zwizku z czym nadal
brakuje wielu rzeczy.

%package devel
Summary:	Development files for klibc
Summary(pl):	Pliki dla programistw klibc
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	binutils
%{?with_dist_kernel:Requires:	kernel-headers >= 2.4}

%description devel
Small libc for building embedded applications - development files.

%description devel -l pl
Maa libc do budowania aplikacji wbudowanych - pliki dla programistw.

%package static
Summary:	Static klibc libraries
Summary(pl):	Biblioteki statyczne klibc
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static klibc libraries.

%description static -l pl
Biblioteki statyczne klibc.

%package utils-shared
Summary:	Utilities dynamically linked with klibc
Summary(pl):	Narzdzia dynamicznie zlinkowane z klibc
Group:		Base
Requires:	%{name} = %{version}-%{release}

%description utils-shared
Utilities dynamically linked with klibc.

%description utils-shared -l pl
Narzdzia dynamicznie zlinkowane z klibc.

%package utils-static
Summary:	Utilities statically linked with klibc
Summary(pl):	Narzdzia statycznie zlinkowane z klibc
Group:		Base

%description utils-static
Utilities staticly linked with klibc.

%description utils-static -l pl
Narzdzia statycznie zlinkowane z klibc.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
rm -rf include/{asm,asm-generic,linux}
%ifarch ppc powerpc
if [ -d %{_kernelsrcdir}/include/asm-powerpc ]; then
	install -d include/asm
	cp -a %{_kernelsrcdir}/include/asm-ppc/* include/asm/
	cp -a %{_kernelsrcdir}/include/asm-powerpc/* include/asm/
else
	ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} include/asm
fi
%else
	ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} include/asm
%endif
cd include
ln -sf %{_kernelsrcdir}/include/asm-generic .
ln -sf %{_kernelsrcdir}/include/linux .
%if %{with dist_kernel}
[ ! -d arch/%{_target_base_arch}/linux ] && mkdir arch/%{_target_base_arch}/linux
ln -sf  %{_kernelsrcdir}/include/linux/autoconf-up.h arch/%{_target_base_arch}/linux/autoconf.h
%endif
for a in `ls arch`; do [ "$a" != "%{_target_base_arch}" ] && rm -rf arch/$a; done
cd ..

%ifarch sparc
# hack; missing dependency in make system
( cd klibc && %{__make} -f arch/sparc/Makefile.inc ARCH=sparc \
        arch/sparc/sdiv.S arch/sparc/udiv.S arch/sparc/srem.S arch/sparc/urem.S )
%endif

%{__make} \
	ARCH=%{_target_base_arch} \
	HOSTCC="%{__cc}" \
	rpm_prefix=%{_prefix} \
	rpm_bindir=%{_bindir} \
	rpm_includedir=%{_includedir}/klibc \
	rpm_libdir=%{_libdir} \
	SHLIBDIR=/%{_lib} \
	OPTFLAGS="%{rpmcflags} -Os -fomit-frame-pointer -falign-functions=0 \
		-falign-jumps=0 -falign-loops=0 -ffreestanding"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/%{_lib}
install -d $RPM_BUILD_ROOT%{_includedir}/klibc
install -d $RPM_BUILD_ROOT%{_libdir}/klibc/bin-{shared,static}

cp -a include/* $RPM_BUILD_ROOT%{_includedir}/klibc
install klcc/klcc -D $RPM_BUILD_ROOT%{_bindir}/klcc
install klcc/klcc.1 -D $RPM_BUILD_ROOT%{_mandir}/man1/klcc.1
install klibc/libc.* klibc/arch/%{_target_base_arch}/crt0.o klibc/interp.o $RPM_BUILD_ROOT%{_libdir}/klibc
install klibc/klibc.so $RPM_BUILD_ROOT/%{_lib}
install dash/sh.shared $RPM_BUILD_ROOT%{_libdir}/klibc/bin-shared/sh
install dash/sh $RPM_BUILD_ROOT%{_libdir}/klibc/bin-static/sh
install utils/shared/* $RPM_BUILD_ROOT%{_libdir}/klibc/bin-shared
install utils/static/* $RPM_BUILD_ROOT%{_libdir}/klibc/bin-static

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) /%{_lib}/klibc.so

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/klcc
%{_includedir}/klibc
%dir %{_libdir}/klibc
%attr(755,root,root) %{_libdir}/klibc/*.so
%{_libdir}/klibc/*.o
%{_mandir}/man1/*

%files static
%defattr(644,root,root,755)
%{_libdir}/klibc/*.a

%files utils-shared
%defattr(644,root,root,755)
%dir %{_libdir}/klibc/bin-shared
%attr(755,root,root) %{_libdir}/klibc/bin-shared/*

%files utils-static
%defattr(644,root,root,755)
%dir %{_libdir}/klibc/bin-static
%attr(755,root,root) %{_libdir}/klibc/bin-static/*

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: klibc.spec,v $
Revision 1.51  2006/01/06 20:19:45  arekm
- hack for sparc + correct cc usage

Revision 1.50  2006/01/06 18:33:39  arekm
- updated (fixes klcc compilation)

Revision 1.49  2006/01/06 18:13:04  arekm
- updated to 1.1.16

Revision 1.48  2006/01/05 10:55:52  kosmo
- add missing BR (bison, flex)
- package shell (ash)

Revision 1.47  2005/11/28 02:50:46  pluto
- support multiple ppc headers.

Revision 1.46  2005/10/10 17:30:15  pluto
- TODO fixed in recent pld 2.6.14 kernel
  http://cvs.pld-linux.org/cgi-bin/cvsweb/SOURCES/kernel-hotfixes.patch?r1=1.1.2.62&r2=1.1.2.63
- removed sohash from klibc's interp.o to avoid rebuild shared userland
  after each klibc upgrade.

Revision 1.45  2005/10/03 16:18:49  qboosh
- no Epoch here - don't use it

Revision 1.44  2005/09/30 19:51:01  pluto
- fix undefined ksh behaviour -> test with >= 4 arguments.
  http://www.opengroup.org/onlinepubs/009695399/utilities/test.html
  catched error: ./mkbuiltins[122]: [: #: unexpected operator/operand

Revision 1.43  2005/09/30 16:31:17  pluto
- fix klibc loader on amd64.

Revision 1.42  2005/09/30 13:24:30  pluto
- last change reverted. this is not a bashism. ksh bug?
  testcase:
   echo '[ "foo" = "bar" -a "-u" = "zoo" ]'|/bin/sh
   /bin/sh: <stdin>[1]: [: zoo: unexpected operator/operand

Revision 1.41  2005/09/30 12:44:35  pluto
- kill bashism in sh script.

Revision 1.40  2005/09/30 11:51:53  pluto
- add jfs support to utils/fstype.
- TODO added (klibc loader crash).

Revision 1.39  2005/09/29 13:32:51  pluto
- don't copy kernel headers. smart linking is enough.
- split to -devel,-static and shared lib.
- release 1.

Revision 1.38  2005/09/29 11:43:24  pluto
- updated to 1.1.1.
- /%{_lib}/klibc-*.so loader added (shared binaries works fine now).
- nfy...

Revision 1.37  2005/07/24 09:36:29  qboosh
- don't overwrite autoconf.h if without dist_kernel

Revision 1.36  2005/06/22 21:35:10  pluto
- updated to 1.0.14.

Revision 1.35  2005/06/13 20:39:32  pluto
- klcc patch reworked (it passes `-static` flag to the linker correctly now).

Revision 1.34  2005/06/13 19:13:11  pluto
- klcc wrapper fixed (static and shared build works fine now).

Revision 1.33  2005/06/13 16:20:39  pluto
- release 1.

Revision 1.32  2005/06/13 16:10:12  pluto
- crossbuild only in (manual) hacker mode.
- alpha patch is obsolete now.

Revision 1.31  2005/06/13 15:33:50  pluto
- crossbuild enabled, license updated.

Revision 1.30  2005/06/13 14:46:29  pluto
- updated to 1.0, nfy (needs !ix86 buildtests).
- klcc wrapper packaged.

Revision 1.29  2005/02/05 22:14:59  adamg
- updated to 0.198

Revision 1.28  2004/12/12 19:44:17  pluto
- attempt to fix an alpha build.

Revision 1.27  2004/12/12 19:07:20  pluto
- updated to 0.193.

Revision 1.26  2004/07/08 20:47:22  qboosh
- 0.150

Revision 1.25  2004/07/03 23:31:19  ankry
- spaces -> tabs

Revision 1.24  2004/07/02 20:55:17  qboosh
- pl for utils

Revision 1.23  2004/07/02 20:21:40  arekm
- utils (this tree structure is bad, any better?)

Revision 1.22  2004/07/02 20:13:37  arekm
- 0.148

Revision 1.21  2004/04/25 13:40:00  qboosh
- updated to 0.116

Revision 1.20  2004/03/07 16:55:47  qboosh
- updated to 0.115

Revision 1.19  2004/02/17 22:35:22  qboosh
- updated to 0.110

Revision 1.18  2004/02/09 20:27:44  qboosh
- updated to 0.105

Revision 1.17  2004/01/31 21:40:22  qboosh
- updated to 0.103

Revision 1.16  2004/01/30 21:50:54  qboosh
- updated to 0.101

Revision 1.15  2004/01/28 19:31:04  qboosh
- updated to 0.100

Revision 1.14  2004/01/26 23:58:15  qboosh
- updated to 0.98

Revision 1.13  2003/12/30 19:47:08  qboosh
- updated to 0.95

Revision 1.12  2003/12/14 00:17:36  qboosh
- updated to 0.94

Revision 1.11  2003/12/08 22:59:03  qboosh
- updated to 0.92

Revision 1.10  2003/12/02 21:50:37  qboosh
- updated to 0.89

Revision 1.9  2003/11/27 22:56:13  qboosh
- typo

Revision 1.8  2003/11/27 22:09:12  ankry
- pl fixes

Revision 1.7  2003/11/27 22:01:56  qboosh
- updated to 0.87
- kernel-source is not needed, only headers (on bcond)

Revision 1.6  2003/10/18 16:29:24  arekm
- updated

Revision 1.5  2003/05/28 12:59:21  malekith
- massive attack: source-md5

Revision 1.4  2003/05/25 05:49:31  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.3  2003/04/11 18:20:58  misiek
- updated to 0.79 (utils and other binaries not packaged)

Revision 1.2  2002/08/12 20:43:15  marcus
- addedd ppc and ppc64
- updated to 0.22
(not tested - I haven't gcc3)

Revision 1.1  2002/08/12 09:00:17  misiek
- kernel libc
